function showClusters(x, m, class)

D = size(x, 1);
K = size(m, 2);

if D > 3
    disp('Can only show points in up to three dimensions')
    return
end

if D == 1
    x = x(:)';
    m = m(:)';
end

if D < 3
    x((D+1):3, :) = 0;
    m((D+1):3, :) = 0;
end

clf

for k = 1:K
    color = colorPick(k);
    ck = find(class == k);
    if ~isempty(ck)
        plot3(x(1, ck), x(2, ck), x(3, ck), sprintf('.%s', color))
        if ~ishold
            hold on
        end
    end
    plot3(m(1, k), m(2, k), m(3, k), sprintf('+%s', color), ...
        'MarkerSize', 18, 'LineWidth', 4)
    if ~ishold
        hold on
    end
end

axis equal
if D < 3
    view(0, 90);
else
    rotate3d on
end

figure(gcf)
drawnow

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function c = colorPick(i)

color = 'rmbgkcy';
%color = 'b';
ncolors = length(color);

c = color(1 + mod(i-1, ncolors));